Index: /trunk/documentation/API Documentation/Assemblies/Update.cmd
===================================================================
--- /trunk/documentation/API Documentation/Assemblies/Update.cmd	(revision 4)
+++ /trunk/documentation/API Documentation/Assemblies/Update.cmd	(revision 4)
@@ -0,0 +1,66 @@
+set configuration=Release
+
+copy ..\..\..\sources\HeuristicLab.AdvancedOptimizationFrontend\bin\%configuration%\HeuristicLab.AdvancedOptimizationFrontend.dll .
+copy ..\..\..\sources\HeuristicLab.AdvancedOptimizationFrontend\bin\%configuration%\HeuristicLab.AdvancedOptimizationFrontend.xml .
+copy ..\..\..\sources\HeuristicLab.AdvancedOptimizationFrontend\bin\%configuration%\WeifenLuo.WinFormsUI.Docking.dll .
+copy ..\..\..\sources\HeuristicLab.BitVector\bin\%configuration%\HeuristicLab.BitVector.dll .
+copy ..\..\..\sources\HeuristicLab.BitVector\bin\%configuration%\HeuristicLab.BitVector.xml .
+copy ..\..\..\sources\HeuristicLab.Charting\bin\%configuration%\HeuristicLab.Charting.dll .
+copy ..\..\..\sources\HeuristicLab.Charting\bin\%configuration%\HeuristicLab.Charting.xml .
+copy ..\..\..\sources\HeuristicLab.Charting.Data\bin\%configuration%\HeuristicLab.Charting.Data.dll .
+copy ..\..\..\sources\HeuristicLab.Charting.Data\bin\%configuration%\HeuristicLab.Charting.Data.xml .
+copy ..\..\..\sources\HeuristicLab.Constraints\bin\%configuration%\HeuristicLab.Constraints.dll .
+copy ..\..\..\sources\HeuristicLab.Constraints\bin\%configuration%\HeuristicLab.Constraints.xml .
+copy ..\..\..\sources\HeuristicLab.Core\bin\%configuration%\HeuristicLab.Core.dll .
+copy ..\..\..\sources\HeuristicLab.Core\bin\%configuration%\HeuristicLab.Core.xml .
+copy ..\..\..\sources\HeuristicLab.Data\bin\%configuration%\HeuristicLab.Data.dll .
+copy ..\..\..\sources\HeuristicLab.Data\bin\%configuration%\HeuristicLab.Data.xml .
+copy ..\..\..\sources\HeuristicLab.DataAnalysis\bin\%configuration%\HeuristicLab.DataAnalysis.dll .
+copy ..\..\..\sources\HeuristicLab.DataAnalysis\bin\%configuration%\HeuristicLab.DataAnalysis.xml .
+copy ..\..\..\sources\HeuristicLab.DistributedEngine\bin\%configuration%\HeuristicLab.DistributedEngine.dll .
+copy ..\..\..\sources\HeuristicLab.DistributedEngine\bin\%configuration%\HeuristicLab.DistributedEngine.xml .
+copy ..\..\..\sources\HeuristicLab.Evolutionary\bin\%configuration%\HeuristicLab.Evolutionary.dll .
+copy ..\..\..\sources\HeuristicLab.Evolutionary\bin\%configuration%\HeuristicLab.Evolutionary.xml .
+copy ..\..\..\sources\HeuristicLab.Functions\bin\%configuration%\HeuristicLab.Functions.dll .
+copy ..\..\..\sources\HeuristicLab.Functions\bin\%configuration%\HeuristicLab.Functions.xml .
+copy ..\..\..\sources\HeuristicLab.Grid\bin\%configuration%\HeuristicLab.Grid.dll .
+copy ..\..\..\sources\HeuristicLab.Grid\bin\%configuration%\HeuristicLab.Grid.xml .
+copy ..\..\..\sources\HeuristicLab.Logging\bin\%configuration%\HeuristicLab.Logging.dll .
+copy ..\..\..\sources\HeuristicLab.Logging\bin\%configuration%\HeuristicLab.Logging.xml .
+copy ..\..\..\sources\HeuristicLab.Operators\bin\%configuration%\HeuristicLab.Operators.dll .
+copy ..\..\..\sources\HeuristicLab.Operators\bin\%configuration%\HeuristicLab.Operators.xml .
+copy ..\..\..\sources\HeuristicLab.Operators.Programmable\bin\%configuration%\HeuristicLab.Operators.Programmable.dll .
+copy ..\..\..\sources\HeuristicLab.Operators.Programmable\bin\%configuration%\HeuristicLab.Operators.Programmable.xml .
+copy ..\..\..\sources\HeuristicLab.OptimizationFrontend\bin\%configuration%\HeuristicLab.OptimizationFrontend.dll .
+copy ..\..\..\sources\HeuristicLab.OptimizationFrontend\bin\%configuration%\HeuristicLab.OptimizationFrontend.xml .
+copy ..\..\..\sources\HeuristicLab.Permutation\bin\%configuration%\HeuristicLab.Permutation.dll .
+copy ..\..\..\sources\HeuristicLab.Permutation\bin\%configuration%\HeuristicLab.Permutation.xml .
+copy ..\..\..\sources\HeuristicLab.PluginInfrastructure\bin\%configuration%\HeuristicLab.PluginInfrastructure.dll .
+copy ..\..\..\sources\HeuristicLab.PluginInfrastructure\bin\%configuration%\HeuristicLab.PluginInfrastructure.xml .
+copy ..\..\..\sources\HeuristicLab.PluginInfrastructure.GUI\bin\%configuration%\HeuristicLab.PluginInfrastructure.GUI.dll .
+copy ..\..\..\sources\HeuristicLab.PluginInfrastructure.GUI\bin\%configuration%\HeuristicLab.PluginInfrastructure.GUI.xml .
+copy ..\..\..\sources\HeuristicLab.PluginInfrastructure.GUI\bin\%configuration%\ICSharpCode.SharpZipLib.dll .
+copy ..\..\..\sources\HeuristicLab.Random\bin\%configuration%\HeuristicLab.Random.dll .
+copy ..\..\..\sources\HeuristicLab.Random\bin\%configuration%\HeuristicLab.Random.xml .
+copy ..\..\..\sources\HeuristicLab.RealVector\bin\%configuration%\HeuristicLab.RealVector.dll .
+copy ..\..\..\sources\HeuristicLab.RealVector\bin\%configuration%\HeuristicLab.RealVector.xml .
+copy ..\..\..\sources\HeuristicLab.Routing.TSP\bin\%configuration%\HeuristicLab.Routing.TSP.dll .
+copy ..\..\..\sources\HeuristicLab.Routing.TSP\bin\%configuration%\HeuristicLab.Routing.TSP.xml .
+copy ..\..\..\sources\HeuristicLab.Scheduling.JSSP\bin\%configuration%\HeuristicLab.Scheduling.JSSP.dll .
+copy ..\..\..\sources\HeuristicLab.Scheduling.JSSP\bin\%configuration%\HeuristicLab.Scheduling.JSSP.xml .
+copy ..\..\..\sources\HeuristicLab.Selection\bin\%configuration%\HeuristicLab.Selection.dll .
+copy ..\..\..\sources\HeuristicLab.Selection\bin\%configuration%\HeuristicLab.Selection.xml .
+copy ..\..\..\sources\HeuristicLab.Selection.OffspringSelection\bin\%configuration%\HeuristicLab.Selection.OffspringSelection.dll .
+copy ..\..\..\sources\HeuristicLab.Selection.OffspringSelection\bin\%configuration%\HeuristicLab.Selection.OffspringSelection.xml .
+copy ..\..\..\sources\HeuristicLab.SequentialEngine\bin\%configuration%\HeuristicLab.SequentialEngine.dll .
+copy ..\..\..\sources\HeuristicLab.SequentialEngine\bin\%configuration%\HeuristicLab.SequentialEngine.xml .
+copy ..\..\..\sources\HeuristicLab.SGA\bin\%configuration%\HeuristicLab.SGA.dll .
+copy ..\..\..\sources\HeuristicLab.SGA\bin\%configuration%\HeuristicLab.SGA.xml .
+copy ..\..\..\sources\HeuristicLab.StructureIdentification\bin\%configuration%\HeuristicLab.StructureIdentification.dll .
+copy ..\..\..\sources\HeuristicLab.StructureIdentification\bin\%configuration%\HeuristicLab.StructureIdentification.xml .
+copy ..\..\..\sources\HeuristicLab.TestFunctions\bin\%configuration%\HeuristicLab.TestFunctions.dll .
+copy ..\..\..\sources\HeuristicLab.TestFunctions\bin\%configuration%\HeuristicLab.TestFunctions.xml .
+copy ..\..\..\sources\HeuristicLab.ThreadParallelEngine\bin\%configuration%\HeuristicLab.ThreadParallelEngine.dll .
+copy ..\..\..\sources\HeuristicLab.ThreadParallelEngine\bin\%configuration%\HeuristicLab.ThreadParallelEngine.xml .
+
+pause
Index: /trunk/documentation/API Documentation/SandcastleBuilder Settings.shfb
===================================================================
--- /trunk/documentation/API Documentation/SandcastleBuilder Settings.shfb	(revision 4)
+++ /trunk/documentation/API Documentation/SandcastleBuilder Settings.shfb	(revision 4)
@@ -0,0 +1,122 @@
+﻿<project schemaVersion="1.6.0.2">
+    <assemblies>
+        <assembly assemblyPath=".\Assemblies\HeuristicLab.AdvancedOptimizationFrontend.dll" xmlCommentsPath=".\Assemblies\HeuristicLab.AdvancedOptimizationFrontend.xml" commentsOnly="False" />
+        <assembly assemblyPath=".\Assemblies\HeuristicLab.BitVector.dll" xmlCommentsPath=".\Assemblies\HeuristicLab.BitVector.xml" commentsOnly="False" />
+        <assembly assemblyPath=".\Assemblies\HeuristicLab.Charting.Data.dll" xmlCommentsPath=".\Assemblies\HeuristicLab.Charting.Data.xml" commentsOnly="False" />
+        <assembly assemblyPath=".\Assemblies\HeuristicLab.Charting.dll" xmlCommentsPath=".\Assemblies\HeuristicLab.Charting.xml" commentsOnly="False" />
+        <assembly assemblyPath=".\Assemblies\HeuristicLab.Constraints.dll" xmlCommentsPath=".\Assemblies\HeuristicLab.Constraints.xml" commentsOnly="False" />
+        <assembly assemblyPath=".\Assemblies\HeuristicLab.Core.dll" xmlCommentsPath=".\Assemblies\HeuristicLab.Core.xml" commentsOnly="False" />
+        <assembly assemblyPath=".\Assemblies\HeuristicLab.Data.dll" xmlCommentsPath=".\Assemblies\HeuristicLab.Data.xml" commentsOnly="False" />
+        <assembly assemblyPath=".\Assemblies\HeuristicLab.DataAnalysis.dll" xmlCommentsPath=".\Assemblies\HeuristicLab.DataAnalysis.xml" commentsOnly="False" />
+        <assembly assemblyPath=".\Assemblies\HeuristicLab.DistributedEngine.dll" xmlCommentsPath=".\Assemblies\HeuristicLab.DistributedEngine.xml" commentsOnly="False" />
+        <assembly assemblyPath=".\Assemblies\HeuristicLab.Evolutionary.dll" xmlCommentsPath=".\Assemblies\HeuristicLab.Evolutionary.xml" commentsOnly="False" />
+        <assembly assemblyPath=".\Assemblies\HeuristicLab.Functions.dll" xmlCommentsPath=".\Assemblies\HeuristicLab.Functions.xml" commentsOnly="False" />
+        <assembly assemblyPath=".\Assemblies\HeuristicLab.Grid.dll" xmlCommentsPath=".\Assemblies\HeuristicLab.Grid.xml" commentsOnly="False" />
+        <assembly assemblyPath=".\Assemblies\HeuristicLab.Logging.dll" xmlCommentsPath=".\Assemblies\HeuristicLab.Logging.xml" commentsOnly="False" />
+        <assembly assemblyPath=".\Assemblies\HeuristicLab.Operators.dll" xmlCommentsPath=".\Assemblies\HeuristicLab.Operators.xml" commentsOnly="False" />
+        <assembly assemblyPath=".\Assemblies\HeuristicLab.Operators.Programmable.dll" xmlCommentsPath=".\Assemblies\HeuristicLab.Operators.Programmable.xml" commentsOnly="False" />
+        <assembly assemblyPath=".\Assemblies\HeuristicLab.OptimizationFrontend.dll" xmlCommentsPath=".\Assemblies\HeuristicLab.OptimizationFrontend.xml" commentsOnly="False" />
+        <assembly assemblyPath=".\Assemblies\HeuristicLab.Permutation.dll" xmlCommentsPath=".\Assemblies\HeuristicLab.Permutation.xml" commentsOnly="False" />
+        <assembly assemblyPath=".\Assemblies\HeuristicLab.PluginInfrastructure.dll" xmlCommentsPath=".\Assemblies\HeuristicLab.PluginInfrastructure.xml" commentsOnly="False" />
+        <assembly assemblyPath=".\Assemblies\HeuristicLab.PluginInfrastructure.GUI.dll" xmlCommentsPath=".\Assemblies\HeuristicLab.PluginInfrastructure.GUI.xml" commentsOnly="False" />
+        <assembly assemblyPath=".\Assemblies\HeuristicLab.Random.dll" xmlCommentsPath=".\Assemblies\HeuristicLab.Random.xml" commentsOnly="False" />
+        <assembly assemblyPath=".\Assemblies\HeuristicLab.RealVector.dll" xmlCommentsPath=".\Assemblies\HeuristicLab.RealVector.xml" commentsOnly="False" />
+        <assembly assemblyPath=".\Assemblies\HeuristicLab.Routing.TSP.dll" xmlCommentsPath=".\Assemblies\HeuristicLab.Routing.TSP.xml" commentsOnly="False" />
+        <assembly assemblyPath=".\Assemblies\HeuristicLab.Scheduling.JSSP.dll" xmlCommentsPath=".\Assemblies\HeuristicLab.Scheduling.JSSP.xml" commentsOnly="False" />
+        <assembly assemblyPath=".\Assemblies\HeuristicLab.Selection.dll" xmlCommentsPath=".\Assemblies\HeuristicLab.Selection.xml" commentsOnly="False" />
+        <assembly assemblyPath=".\Assemblies\HeuristicLab.Selection.OffspringSelection.dll" xmlCommentsPath=".\Assemblies\HeuristicLab.Selection.OffspringSelection.xml" commentsOnly="False" />
+        <assembly assemblyPath=".\Assemblies\HeuristicLab.SequentialEngine.dll" xmlCommentsPath=".\Assemblies\HeuristicLab.SequentialEngine.xml" commentsOnly="False" />
+        <assembly assemblyPath=".\Assemblies\HeuristicLab.SGA.dll" xmlCommentsPath=".\Assemblies\HeuristicLab.SGA.xml" commentsOnly="False" />
+        <assembly assemblyPath=".\Assemblies\HeuristicLab.StructureIdentification.dll" xmlCommentsPath=".\Assemblies\HeuristicLab.StructureIdentification.xml" commentsOnly="False" />
+        <assembly assemblyPath=".\Assemblies\HeuristicLab.TestFunctions.dll" xmlCommentsPath=".\Assemblies\HeuristicLab.TestFunctions.xml" commentsOnly="False" />
+        <assembly assemblyPath=".\Assemblies\HeuristicLab.ThreadParallelEngine.dll" xmlCommentsPath=".\Assemblies\HeuristicLab.ThreadParallelEngine.xml" commentsOnly="False" />
+    </assemblies>
+    <namespaceSummaries>
+        <namespaceSummaryItem name="" isDocumented="False" />
+        <namespaceSummaryItem name="HeuristicLab.AdvancedOptimizationFrontend" isDocumented="True" />
+        <namespaceSummaryItem name="HeuristicLab.AdvancedOptimizationFrontend.Properties" isDocumented="True" />
+        <namespaceSummaryItem name="HeuristicLab.BitVector" isDocumented="True" />
+        <namespaceSummaryItem name="HeuristicLab.Charting" isDocumented="True" />
+        <namespaceSummaryItem name="HeuristicLab.Charting.Data" isDocumented="True" />
+        <namespaceSummaryItem name="HeuristicLab.Constraints" isDocumented="True" />
+        <namespaceSummaryItem name="HeuristicLab.Core" isDocumented="True">HeuristicLab.Core Namespace Summary
+
+(... to be continued ...)</namespaceSummaryItem>
+        <namespaceSummaryItem name="HeuristicLab.Core.Properties" isDocumented="True" />
+        <namespaceSummaryItem name="HeuristicLab.Data" isDocumented="True">HeuristicLab.Data Namespace Summary
+
+(... to be continued ...)</namespaceSummaryItem>
+        <namespaceSummaryItem name="HeuristicLab.DataAnalysis" isDocumented="True" />
+        <namespaceSummaryItem name="HeuristicLab.DistributedEngine" isDocumented="True" />
+        <namespaceSummaryItem name="HeuristicLab.Evolutionary" isDocumented="True" />
+        <namespaceSummaryItem name="HeuristicLab.Functions" isDocumented="True" />
+        <namespaceSummaryItem name="HeuristicLab.Grid" isDocumented="True" />
+        <namespaceSummaryItem name="HeuristicLab.Logging" isDocumented="True" />
+        <namespaceSummaryItem name="HeuristicLab.Operators" isDocumented="True" />
+        <namespaceSummaryItem name="HeuristicLab.Operators.Programmable" isDocumented="True" />
+        <namespaceSummaryItem name="HeuristicLab.OptimizationFrontend" isDocumented="True" />
+        <namespaceSummaryItem name="HeuristicLab.OptimizationFrontend.Properties" isDocumented="True" />
+        <namespaceSummaryItem name="HeuristicLab.Permutation" isDocumented="True" />
+        <namespaceSummaryItem name="HeuristicLab.PluginInfrastructure" isDocumented="True" />
+        <namespaceSummaryItem name="HeuristicLab.PluginInfrastructure.GUI" isDocumented="True" />
+        <namespaceSummaryItem name="HeuristicLab.PluginInfrastructure.GUI.Properties" isDocumented="True" />
+        <namespaceSummaryItem name="HeuristicLab.PluginInfrastructure.Properties" isDocumented="True" />
+        <namespaceSummaryItem name="HeuristicLab.Random" isDocumented="True">HeuristicLab.Random Namespace Summary
+
+(... to be continued ...)</namespaceSummaryItem>
+        <namespaceSummaryItem name="HeuristicLab.RealVector" isDocumented="True" />
+        <namespaceSummaryItem name="HeuristicLab.Routing.TSP" isDocumented="True">HeuristicLab.Routing.TSP Namespace Summary
+
+(... to be continued ...)</namespaceSummaryItem>
+        <namespaceSummaryItem name="HeuristicLab.Scheduling.JSSP" isDocumented="True" />
+        <namespaceSummaryItem name="HeuristicLab.Selection" isDocumented="True" />
+        <namespaceSummaryItem name="HeuristicLab.Selection.OffspringSelection" isDocumented="True" />
+        <namespaceSummaryItem name="HeuristicLab.SequentialEngine" isDocumented="True" />
+        <namespaceSummaryItem name="HeuristicLab.SGA" isDocumented="True" />
+        <namespaceSummaryItem name="HeuristicLab.StructureIdentification" isDocumented="True" />
+        <namespaceSummaryItem name="HeuristicLab.TestFunctions" isDocumented="True" />
+        <namespaceSummaryItem name="HeuristicLab.ThreadParallelEngine" isDocumented="True" />
+    </namespaceSummaries>
+    <dependencies>
+        <dependencyItem depPath=".\Assemblies\*.*" />
+    </dependencies>
+    <ProjectSummary>HeuristicLab Project Summary
+
+(... to be continued ...)</ProjectSummary>
+    <MissingTags>Summary, Parameter, Returns, AutoDocumentCtors, Namespace</MissingTags>
+    <VisibleItems>Attributes, ExplicitInterfaceImplementations, InheritedMembers, InheritedFrameworkMembers, Internals, Protected, SealedProtected</VisibleItems>
+    <HtmlHelp1xCompilerPath path="..\..\..\..\..\..\Program Files\HTML Help Workshop\" />
+    <HtmlHelp2xCompilerPath path="..\..\..\..\..\..\Program Files\HTML Help Workshop\" />
+    <OutputPath>.\</OutputPath>
+    <SandcastlePath path="..\..\..\..\..\..\Program Files\Sandcastle\" />
+    <WorkingPath path="" />
+    <CleanIntermediates>True</CleanIntermediates>
+    <KeepLogFile>True</KeepLogFile>
+    <HelpFileFormat>HtmlHelp1x</HelpFileFormat>
+    <PurgeDuplicateTopics>True</PurgeDuplicateTopics>
+    <CppCommentsFixup>False</CppCommentsFixup>
+    <FrameworkVersion>2.0.50727</FrameworkVersion>
+    <BinaryTOC>True</BinaryTOC>
+    <IncludeFavorites>False</IncludeFavorites>
+    <Preliminary>True</Preliminary>
+    <RootNamespaceContainer>False</RootNamespaceContainer>
+    <RootNamespaceTitle />
+    <HelpTitle>HeuristicLab API Documentation</HelpTitle>
+    <HtmlHelpName>HeuristicLab API Documentation</HtmlHelpName>
+    <Language>en-US</Language>
+    <CopyrightHref>http://www.heuristiclab.com</CopyrightHref>
+    <CopyrightText>(c) 2002-2008 HEAL</CopyrightText>
+    <FeedbackEMailAddress>support@heuristiclab.com</FeedbackEMailAddress>
+    <HeaderText />
+    <FooterText />
+    <ProjectLinkType>Local</ProjectLinkType>
+    <SdkLinkType>Msdn</SdkLinkType>
+    <SdkLinkTarget>Blank</SdkLinkTarget>
+    <PresentationStyle>vs2005</PresentationStyle>
+    <NamingMethod>Guid</NamingMethod>
+    <SyntaxFilters>CSharp</SyntaxFilters>
+    <ShowFeedbackControl>False</ShowFeedbackControl>
+    <ContentPlacement>AboveNamespaces</ContentPlacement>
+    <ContentSiteMap path="" />
+    <TopicFileTransform path="" />
+</project>
Index: /trunk/sources/HeuristicLab.DataAnalysis/HeuristicLab.DataAnalysis.csproj
===================================================================
--- /trunk/sources/HeuristicLab.DataAnalysis/HeuristicLab.DataAnalysis.csproj	(revision 3)
+++ /trunk/sources/HeuristicLab.DataAnalysis/HeuristicLab.DataAnalysis.csproj	(revision 4)
@@ -32,4 +32,5 @@
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+    <DocumentationFile>bin\Release\HeuristicLab.DataAnalysis.XML</DocumentationFile>
   </PropertyGroup>
   <ItemGroup>
Index: /trunk/sources/HeuristicLab.DistributedEngine/HeuristicLab.DistributedEngine.csproj
===================================================================
--- /trunk/sources/HeuristicLab.DistributedEngine/HeuristicLab.DistributedEngine.csproj	(revision 3)
+++ /trunk/sources/HeuristicLab.DistributedEngine/HeuristicLab.DistributedEngine.csproj	(revision 4)
@@ -30,4 +30,5 @@
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+    <DocumentationFile>bin\Release\HeuristicLab.DistributedEngine.XML</DocumentationFile>
   </PropertyGroup>
   <ItemGroup>
Index: /trunk/sources/HeuristicLab.Functions/HeuristicLab.Functions.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Functions/HeuristicLab.Functions.csproj	(revision 3)
+++ /trunk/sources/HeuristicLab.Functions/HeuristicLab.Functions.csproj	(revision 4)
@@ -35,4 +35,5 @@
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+    <DocumentationFile>bin\Release\HeuristicLab.Functions.XML</DocumentationFile>
   </PropertyGroup>
   <ItemGroup>
Index: /trunk/sources/HeuristicLab.Grid/HeuristicLab.Grid.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Grid/HeuristicLab.Grid.csproj	(revision 3)
+++ /trunk/sources/HeuristicLab.Grid/HeuristicLab.Grid.csproj	(revision 4)
@@ -30,4 +30,5 @@
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+    <DocumentationFile>bin\Release\HeuristicLab.Grid.XML</DocumentationFile>
   </PropertyGroup>
   <ItemGroup>
Index: /trunk/sources/HeuristicLab.PluginInfrastructure.GUI/HeuristicLab.PluginInfrastructure.GUI.csproj
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure.GUI/HeuristicLab.PluginInfrastructure.GUI.csproj	(revision 3)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure.GUI/HeuristicLab.PluginInfrastructure.GUI.csproj	(revision 4)
@@ -36,4 +36,5 @@
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+    <DocumentationFile>bin\Release\HeuristicLab.PluginInfrastructure.GUI.XML</DocumentationFile>
   </PropertyGroup>
   <ItemGroup>
Index: /trunk/sources/HeuristicLab.Scheduling.JSSP/HeuristicLab.Scheduling.JSSP.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Scheduling.JSSP/HeuristicLab.Scheduling.JSSP.csproj	(revision 3)
+++ /trunk/sources/HeuristicLab.Scheduling.JSSP/HeuristicLab.Scheduling.JSSP.csproj	(revision 4)
@@ -51,4 +51,5 @@
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+    <DocumentationFile>bin\Release\HeuristicLab.Scheduling.JSSP.XML</DocumentationFile>
   </PropertyGroup>
   <ItemGroup>
Index: /trunk/sources/HeuristicLab.StructureIdentification/HeuristicLab.StructureIdentification.csproj
===================================================================
--- /trunk/sources/HeuristicLab.StructureIdentification/HeuristicLab.StructureIdentification.csproj	(revision 3)
+++ /trunk/sources/HeuristicLab.StructureIdentification/HeuristicLab.StructureIdentification.csproj	(revision 4)
@@ -35,4 +35,5 @@
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+    <DocumentationFile>bin\Release\HeuristicLab.StructureIdentification.XML</DocumentationFile>
   </PropertyGroup>
   <ItemGroup>