Index: /trunk/sources/HeuristicLab.AdvancedOptimizationFrontend/HeuristicLab.AdvancedOptimizationFrontend.csproj
===================================================================
--- /trunk/sources/HeuristicLab.AdvancedOptimizationFrontend/HeuristicLab.AdvancedOptimizationFrontend.csproj	(revision 4)
+++ /trunk/sources/HeuristicLab.AdvancedOptimizationFrontend/HeuristicLab.AdvancedOptimizationFrontend.csproj	(revision 5)
@@ -103,4 +103,5 @@
     <Content Include="Resources\SaveAll.png" />
     <Content Include="Resources\Tools.ico" />
+    <Content Include="WeifenLuo.WinFormsUI.Docking License.txt" />
     <Content Include="WeifenLuo.WinFormsUI.Docking.dll" />
   </ItemGroup>
Index: /trunk/sources/HeuristicLab.AdvancedOptimizationFrontend/HeuristicLabAdvancedOptimizationFrontendPlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.AdvancedOptimizationFrontend/HeuristicLabAdvancedOptimizationFrontendPlugin.cs	(revision 4)
+++ /trunk/sources/HeuristicLab.AdvancedOptimizationFrontend/HeuristicLabAdvancedOptimizationFrontendPlugin.cs	(revision 5)
@@ -30,4 +30,5 @@
   [PluginFile(Filename = "HeuristicLab.AdvancedOptimizationFrontend.dll", Filetype = PluginFileType.Assembly)]
   [PluginFile(Filename = "WeifenLuo.WinFormsUI.Docking.dll", Filetype = PluginFileType.Assembly)]
+  [PluginFile(Filename = "WeifenLuo.WinFormsUI.Docking License.txt", Filetype = PluginFileType.License)]
   [Dependency(Dependency = "HeuristicLab.Core")]
   public class HeuristicLabAdvancedOptimizationFrontendPlugin : PluginBase {
Index: /trunk/sources/HeuristicLab.AdvancedOptimizationFrontend/WeifenLuo.WinFormsUI.Docking License.txt
===================================================================
--- /trunk/sources/HeuristicLab.AdvancedOptimizationFrontend/WeifenLuo.WinFormsUI.Docking License.txt	(revision 5)
+++ /trunk/sources/HeuristicLab.AdvancedOptimizationFrontend/WeifenLuo.WinFormsUI.Docking License.txt	(revision 5)
@@ -0,0 +1,9 @@
+The MIT License
+
+Copyright (c) 2007 Weifen Luo (email: weifenluo@yahoo.com)
+
+Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
+
+The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
+
+THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
Index: /trunk/sources/HeuristicLab.PluginInfrastructure.GUI/HeuristicLab.PluginInfrastructure.GUI.csproj
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure.GUI/HeuristicLab.PluginInfrastructure.GUI.csproj	(revision 4)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure.GUI/HeuristicLab.PluginInfrastructure.GUI.csproj	(revision 5)
@@ -142,4 +142,5 @@
   </ItemGroup>
   <ItemGroup>
+    <Content Include="ICSharpCode.SharpZipLib License.txt" />
     <Content Include="ICSharpCode.SharpZipLib.dll" />
   </ItemGroup>
Index: /trunk/sources/HeuristicLab.PluginInfrastructure.GUI/ICSharpCode.SharpZipLib License.txt
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure.GUI/ICSharpCode.SharpZipLib License.txt	(revision 5)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure.GUI/ICSharpCode.SharpZipLib License.txt	(revision 5)
@@ -0,0 +1,13 @@
+#ziplib (SharpZipLib, formerly NZipLib) is a Zip, GZip, Tar and BZip2 library written entirely in C# for the .NET platform. It is implemented as an assembly (installable in the GAC), and thus can easily be incorporated into other projects (in any .NET language). The creator of #ziplib put it this way: "I've ported the zip library over to C# because I needed gzip/zip compression and I didn't want to use libzip.dll or something like this. I want all in pure C#."
+
+License
+
+The library is released under the GPL with the following exception:
+
+Linking this library statically or dynamically with other modules is making a combined work based on this library. Thus, the terms and conditions of the GNU General Public License cover the whole combination.
+
+As a special exception, the copyright holders of this library give you permission to link this library with independent modules to produce an executable, regardless of the license terms of these independent modules, and to copy and distribute the resulting executable under terms of your choice, provided that you also meet, for each linked independent module, the terms and conditions of the license of that module. An independent module is a module which is not derived from or based on this library. If you modify this library, you may extend this exception to your version of the library, but you are not obligated to do so. If you do not wish to do so, delete this exception statement from your version.
+
+Note: The exception is changed to reflect the latest GNU Classpath exception. Older versions of #ziplib did have another exception, but the new one is clearer and it doesn't break compatibility with the old one.
+
+Bottom line: In plain English this means you can use this library in commercial closed-source applications.
Index: /trunk/sources/HeuristicLab.PluginInfrastructure/PluginFileAttribute.cs
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/PluginFileAttribute.cs	(revision 4)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/PluginFileAttribute.cs	(revision 5)
@@ -25,6 +25,11 @@
 
 namespace HeuristicLab.PluginInfrastructure {
-  public enum PluginFileType { Assembly, Executable, Data };
-  
+  public enum PluginFileType {
+    Assembly,
+    Executable,
+    Data,
+    License
+  };
+
   [AttributeUsage(AttributeTargets.Class, AllowMultiple=true)]
   public class PluginFileAttribute : System.Attribute {
Index: /trunk/sources/HeuristicLab/UpdateAssemblies.cmd
===================================================================
--- /trunk/sources/HeuristicLab/UpdateAssemblies.cmd	(revision 4)
+++ /trunk/sources/HeuristicLab/UpdateAssemblies.cmd	(revision 5)
@@ -1,2 +1,4 @@
+copy "..\..\..\HeuristicLab.PluginInfrastructure.GUI\ICSharpCode.SharpZipLib License.txt" .\
+
 rmdir plugins /s /q 
 mkdir plugins
@@ -4,31 +6,32 @@
 mkdir plugins\temp
 mkdir plugins\backup
-copy ..\..\..\HeuristicLab.AdvancedOptimizationFrontend\bin\%1\HeuristicLab.AdvancedOptimizationFrontend.dll .\plugins
-copy ..\..\..\HeuristicLab.AdvancedOptimizationFrontend\bin\%1\WeifenLuo.WinFormsUI.Docking.dll .\plugins
-copy ..\..\..\HeuristicLab.BitVector\bin\%1\HeuristicLab.BitVector.dll .\plugins
-copy ..\..\..\HeuristicLab.Charting\bin\%1\HeuristicLab.Charting.dll .\plugins
-copy ..\..\..\HeuristicLab.Charting.Data\bin\%1\HeuristicLab.Charting.Data.dll .\plugins
-copy ..\..\..\HeuristicLab.Core\bin\%1\HeuristicLab.Core.dll .\plugins
-copy ..\..\..\HeuristicLab.Constraints\bin\%1\HeuristicLab.Constraints.dll .\plugins
-copy ..\..\..\HeuristicLab.Data\bin\%1\HeuristicLab.Data.dll .\plugins
-copy ..\..\..\HeuristicLab.DataAnalysis\bin\%1\HeuristicLab.DataAnalysis.dll .\plugins
-copy ..\..\..\HeuristicLab.DistributedEngine\bin\%1\HeuristicLab.DistributedEngine.dll .\plugins
-copy ..\..\..\HeuristicLab.Evolutionary\bin\%1\HeuristicLab.Evolutionary.dll .\plugins
-copy ..\..\..\HeuristicLab.Functions\bin\%1\HeuristicLab.Functions.dll .\plugins
-copy ..\..\..\HeuristicLab.Grid\bin\%1\HeuristicLab.Grid.dll .\plugins
-copy ..\..\..\HeuristicLab.Logging\bin\%1\HeuristicLab.Logging.dll .\plugins
-copy ..\..\..\HeuristicLab.Operators\bin\%1\HeuristicLab.Operators.dll .\plugins
-copy ..\..\..\HeuristicLab.Operators.Programmable\bin\%1\HeuristicLab.Operators.Programmable.dll .\plugins
-copy ..\..\..\HeuristicLab.OptimizationFrontend\bin\%1\HeuristicLab.OptimizationFrontend.dll .\plugins
-copy ..\..\..\HeuristicLab.Permutation\bin\%1\HeuristicLab.Permutation.dll .\plugins
-copy ..\..\..\HeuristicLab.Random\bin\%1\HeuristicLab.Random.dll .\plugins
-copy ..\..\..\HeuristicLab.RealVector\bin\%1\HeuristicLab.RealVector.dll .\plugins
-copy ..\..\..\HeuristicLab.Routing.TSP\bin\%1\HeuristicLab.Routing.TSP.dll .\plugins
-copy ..\..\..\HeuristicLab.Scheduling.JSSP\bin\%1\HeuristicLab.Scheduling.JSSP.dll .\plugins
-copy ..\..\..\HeuristicLab.Selection\bin\%1\HeuristicLab.Selection.dll .\plugins
-copy ..\..\..\HeuristicLab.Selection.OffspringSelection\bin\%1\HeuristicLab.Selection.OffspringSelection.dll .\plugins
-copy ..\..\..\HeuristicLab.SequentialEngine\bin\%1\HeuristicLab.SequentialEngine.dll .\plugins
-copy ..\..\..\HeuristicLab.SGA\bin\%1\HeuristicLab.SGA.dll .\plugins
-copy ..\..\..\HeuristicLab.StructureIdentification\bin\%1\HeuristicLab.StructureIdentification.dll .\plugins
-copy ..\..\..\HeuristicLab.TestFunctions\bin\%1\HeuristicLab.TestFunctions.dll .\plugins
-copy ..\..\..\HeuristicLab.ThreadParallelEngine\bin\%1\HeuristicLab.ThreadParallelEngine.dll .\plugins
+copy "..\..\..\HeuristicLab.AdvancedOptimizationFrontend\bin\%1\HeuristicLab.AdvancedOptimizationFrontend.dll" .\plugins
+copy "..\..\..\HeuristicLab.AdvancedOptimizationFrontend\WeifenLuo.WinFormsUI.Docking.dll" .\plugins
+copy "..\..\..\HeuristicLab.AdvancedOptimizationFrontend\WeifenLuo.WinFormsUI.Docking License.txt" .\plugins
+copy "..\..\..\HeuristicLab.BitVector\bin\%1\HeuristicLab.BitVector.dll" .\plugins
+copy "..\..\..\HeuristicLab.Charting\bin\%1\HeuristicLab.Charting.dll" .\plugins
+copy "..\..\..\HeuristicLab.Charting.Data\bin\%1\HeuristicLab.Charting.Data.dll" .\plugins
+copy "..\..\..\HeuristicLab.Core\bin\%1\HeuristicLab.Core.dll" .\plugins
+copy "..\..\..\HeuristicLab.Constraints\bin\%1\HeuristicLab.Constraints.dll" .\plugins
+copy "..\..\..\HeuristicLab.Data\bin\%1\HeuristicLab.Data.dll" .\plugins
+copy "..\..\..\HeuristicLab.DataAnalysis\bin\%1\HeuristicLab.DataAnalysis.dll" .\plugins
+copy "..\..\..\HeuristicLab.DistributedEngine\bin\%1\HeuristicLab.DistributedEngine.dll" .\plugins
+copy "..\..\..\HeuristicLab.Evolutionary\bin\%1\HeuristicLab.Evolutionary.dll" .\plugins
+copy "..\..\..\HeuristicLab.Functions\bin\%1\HeuristicLab.Functions.dll" .\plugins
+copy "..\..\..\HeuristicLab.Grid\bin\%1\HeuristicLab.Grid.dll" .\plugins
+copy "..\..\..\HeuristicLab.Logging\bin\%1\HeuristicLab.Logging.dll" .\plugins
+copy "..\..\..\HeuristicLab.Operators\bin\%1\HeuristicLab.Operators.dll" .\plugins
+copy "..\..\..\HeuristicLab.Operators.Programmable\bin\%1\HeuristicLab.Operators.Programmable.dll" .\plugins
+copy "..\..\..\HeuristicLab.OptimizationFrontend\bin\%1\HeuristicLab.OptimizationFrontend.dll" .\plugins
+copy "..\..\..\HeuristicLab.Permutation\bin\%1\HeuristicLab.Permutation.dll" .\plugins
+copy "..\..\..\HeuristicLab.Random\bin\%1\HeuristicLab.Random.dll" .\plugins
+copy "..\..\..\HeuristicLab.RealVector\bin\%1\HeuristicLab.RealVector.dll" .\plugins
+copy "..\..\..\HeuristicLab.Routing.TSP\bin\%1\HeuristicLab.Routing.TSP.dll" .\plugins
+copy "..\..\..\HeuristicLab.Scheduling.JSSP\bin\%1\HeuristicLab.Scheduling.JSSP.dll" .\plugins
+copy "..\..\..\HeuristicLab.Selection\bin\%1\HeuristicLab.Selection.dll" .\plugins
+copy "..\..\..\HeuristicLab.Selection.OffspringSelection\bin\%1\HeuristicLab.Selection.OffspringSelection.dll" .\plugins
+copy "..\..\..\HeuristicLab.SequentialEngine\bin\%1\HeuristicLab.SequentialEngine.dll" .\plugins
+copy "..\..\..\HeuristicLab.SGA\bin\%1\HeuristicLab.SGA.dll" .\plugins
+copy "..\..\..\HeuristicLab.StructureIdentification\bin\%1\HeuristicLab.StructureIdentification.dll" .\plugins
+copy "..\..\..\HeuristicLab.TestFunctions\bin\%1\HeuristicLab.TestFunctions.dll" .\plugins
+copy "..\..\..\HeuristicLab.ThreadParallelEngine\bin\%1\HeuristicLab.ThreadParallelEngine.dll" .\plugins