Index: trunk/sources/HeuristicLab.PluginInfrastructure.GUI/ManagerForm.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure.GUI/ManagerForm.cs	(revision 17)
+++ trunk/sources/HeuristicLab.PluginInfrastructure.GUI/ManagerForm.cs	(revision 18)
@@ -61,8 +61,8 @@
       installMenuItem.Enabled = false;
       installMenuItem.Checked = false;
-      removeButton.Enabled = false;
-      removeButton.Checked = false;
-      removeMenuItem.Enabled = false;
-      removeMenuItem.Checked = false;
+      deleteButton.Enabled = false;
+      deleteButton.Checked = false;
+      deleteMenuItem.Enabled = false;
+      deleteMenuItem.Checked = false;
 
       installedPlugins = new TreeNode("Installed plugins");
@@ -567,14 +567,14 @@
       publishButton.Enabled = (tag.State & PluginState.Installed) == PluginState.Installed;
       installButton.Enabled = (tag.State & PluginState.Available) == PluginState.Available;
-      removeButton.Enabled = (tag.State & (PluginState.Installed | PluginState.Upgradeable)) != 0;
+      deleteButton.Enabled = (tag.State & (PluginState.Installed | PluginState.Upgradeable)) != 0;
 
       installButton.Checked = GetAction(tag) == ManagerAction.Install;
-      removeButton.Checked = GetAction(tag) == ManagerAction.Remove;
+      deleteButton.Checked = GetAction(tag) == ManagerAction.Remove;
 
       publishMenuItem.Enabled = publishButton.Enabled;
       installMenuItem.Enabled = installButton.Enabled;
-      removeMenuItem.Enabled = removeButton.Enabled;
+      deleteMenuItem.Enabled = deleteButton.Enabled;
       installMenuItem.Checked = installButton.Checked;
-      removeMenuItem.Checked = removeButton.Checked;
+      deleteMenuItem.Checked = deleteButton.Checked;
 
     }
@@ -957,5 +957,5 @@
         publishButton.Enabled = false;
         installButton.Enabled = false;
-        removeButton.Enabled = false;
+        deleteButton.Enabled = false;
       }
     }
@@ -1010,4 +1010,12 @@
     }
 
+    private void pluginTreeView_KeyPress(object sender, KeyPressEventArgs e) {
+      e.Handled = true;
+      if(e.KeyChar == 'i' && installButton.Enabled) {
+        installButton_Clicked(sender, e);
+      } else if(e.KeyChar == 'd' && deleteButton.Enabled) {
+        removeButton_Clicked(sender, e);
+      }
+    }
   }
 }
Index: trunk/sources/HeuristicLab.PluginInfrastructure.GUI/ManagerForm.designer.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure.GUI/ManagerForm.designer.cs	(revision 17)
+++ trunk/sources/HeuristicLab.PluginInfrastructure.GUI/ManagerForm.designer.cs	(revision 18)
@@ -68,10 +68,10 @@
       this.toolStripSeparator = new System.Windows.Forms.ToolStripSeparator();
       this.installButton = new System.Windows.Forms.ToolStripButton();
-      this.removeButton = new System.Windows.Forms.ToolStripButton();
+      this.deleteButton = new System.Windows.Forms.ToolStripButton();
       this.toolStripSeparator1 = new System.Windows.Forms.ToolStripSeparator();
       this.publishButton = new System.Windows.Forms.ToolStripButton();
       this.pluginContextMenuStrip = new System.Windows.Forms.ContextMenuStrip(this.components);
       this.installMenuItem = new System.Windows.Forms.ToolStripMenuItem();
-      this.removeMenuItem = new System.Windows.Forms.ToolStripMenuItem();
+      this.deleteMenuItem = new System.Windows.Forms.ToolStripMenuItem();
       this.publishMenuItem = new System.Windows.Forms.ToolStripMenuItem();
       this.menuStrip.SuspendLayout();
@@ -138,6 +138,6 @@
       // 
       this.installNewPluginsToolStripMenuItem.Name = "installNewPluginsToolStripMenuItem";
-      this.installNewPluginsToolStripMenuItem.Size = new System.Drawing.Size(214, 22);
-      this.installNewPluginsToolStripMenuItem.Text = "Remove/Upgrade/Install...";
+      this.installNewPluginsToolStripMenuItem.Size = new System.Drawing.Size(206, 22);
+      this.installNewPluginsToolStripMenuItem.Text = "Delete/Upgrade/Install...";
       this.installNewPluginsToolStripMenuItem.Click += new System.EventHandler(this.upgradeButton_Click);
       // 
@@ -206,4 +206,5 @@
       this.pluginTreeView.Size = new System.Drawing.Size(828, 220);
       this.pluginTreeView.TabIndex = 0;
+      this.pluginTreeView.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.pluginTreeView_KeyPress);
       this.pluginTreeView.NodeMouseClick += new System.Windows.Forms.TreeNodeMouseClickEventHandler(this.pluginTreeView_NodeMouseClick);
       this.pluginTreeView.BeforeSelect += new System.Windows.Forms.TreeViewCancelEventHandler(this.pluginTreeView_BeforeSelect);
@@ -235,5 +236,5 @@
             this.toolStripSeparator,
             this.installButton,
-            this.removeButton,
+            this.deleteButton,
             this.toolStripSeparator1,
             this.publishButton});
@@ -251,5 +252,5 @@
       this.updateButton.Name = "updateButton";
       this.updateButton.Size = new System.Drawing.Size(46, 22);
-      this.updateButton.Text = "U&pdate";
+      this.updateButton.Text = "Update";
       this.updateButton.Click += new System.EventHandler(this.updateButton_Click);
       // 
@@ -260,6 +261,6 @@
       this.upgradeButton.ImageTransparentColor = System.Drawing.Color.Magenta;
       this.upgradeButton.Name = "upgradeButton";
-      this.upgradeButton.Size = new System.Drawing.Size(140, 22);
-      this.upgradeButton.Text = "Remove/&Upgrade/Install...";
+      this.upgradeButton.Size = new System.Drawing.Size(132, 22);
+      this.upgradeButton.Text = "Delete/Upgrade/Install...";
       this.upgradeButton.Click += new System.EventHandler(this.upgradeButton_Click);
       // 
@@ -280,14 +281,14 @@
       this.installButton.Click += new System.EventHandler(this.installButton_Clicked);
       // 
-      // removeButton
-      // 
-      this.removeButton.CheckOnClick = true;
-      this.removeButton.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Text;
-      this.removeButton.Image = ((System.Drawing.Image)(resources.GetObject("removeButton.Image")));
-      this.removeButton.ImageTransparentColor = System.Drawing.Color.Magenta;
-      this.removeButton.Name = "removeButton";
-      this.removeButton.Size = new System.Drawing.Size(50, 22);
-      this.removeButton.Text = "&Remove";
-      this.removeButton.Click += new System.EventHandler(this.removeButton_Clicked);
+      // deleteButton
+      // 
+      this.deleteButton.CheckOnClick = true;
+      this.deleteButton.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Text;
+      this.deleteButton.Image = ((System.Drawing.Image)(resources.GetObject("deleteButton.Image")));
+      this.deleteButton.ImageTransparentColor = System.Drawing.Color.Magenta;
+      this.deleteButton.Name = "deleteButton";
+      this.deleteButton.Size = new System.Drawing.Size(42, 22);
+      this.deleteButton.Text = "&Delete";
+      this.deleteButton.Click += new System.EventHandler(this.removeButton_Clicked);
       // 
       // toolStripSeparator1
@@ -310,27 +311,27 @@
       this.pluginContextMenuStrip.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
             this.installMenuItem,
-            this.removeMenuItem,
+            this.deleteMenuItem,
             this.publishMenuItem});
       this.pluginContextMenuStrip.Name = "pluginContextMenuStrip";
-      this.pluginContextMenuStrip.Size = new System.Drawing.Size(125, 70);
+      this.pluginContextMenuStrip.Size = new System.Drawing.Size(119, 70);
       // 
       // installMenuItem
       // 
       this.installMenuItem.Name = "installMenuItem";
-      this.installMenuItem.Size = new System.Drawing.Size(124, 22);
+      this.installMenuItem.Size = new System.Drawing.Size(152, 22);
       this.installMenuItem.Text = "Install";
       this.installMenuItem.Click += new System.EventHandler(this.installButton_Clicked);
       // 
-      // removeMenuItem
-      // 
-      this.removeMenuItem.Name = "removeMenuItem";
-      this.removeMenuItem.Size = new System.Drawing.Size(124, 22);
-      this.removeMenuItem.Text = "Remove";
-      this.removeMenuItem.Click += new System.EventHandler(this.removeButton_Clicked);
+      // deleteMenuItem
+      // 
+      this.deleteMenuItem.Name = "deleteMenuItem";
+      this.deleteMenuItem.Size = new System.Drawing.Size(118, 22);
+      this.deleteMenuItem.Text = "Delete";
+      this.deleteMenuItem.Click += new System.EventHandler(this.removeButton_Clicked);
       // 
       // publishMenuItem
       // 
       this.publishMenuItem.Name = "publishMenuItem";
-      this.publishMenuItem.Size = new System.Drawing.Size(124, 22);
+      this.publishMenuItem.Size = new System.Drawing.Size(152, 22);
       this.publishMenuItem.Text = "Publish";
       this.publishMenuItem.Click += new System.EventHandler(this.publishButton_Click);
@@ -379,5 +380,5 @@
     private System.Windows.Forms.ToolStripSeparator toolStripSeparator;
     private System.Windows.Forms.ToolStripButton installButton;
-    private System.Windows.Forms.ToolStripButton removeButton;
+    private System.Windows.Forms.ToolStripButton deleteButton;
     private System.Windows.Forms.ToolStripMenuItem exitToolStripMenuItem;
     private System.Windows.Forms.ToolStripSeparator toolStripSeparator1;
@@ -385,5 +386,5 @@
     private System.Windows.Forms.ContextMenuStrip pluginContextMenuStrip;
     private System.Windows.Forms.ToolStripMenuItem installMenuItem;
-    private System.Windows.Forms.ToolStripMenuItem removeMenuItem;
+    private System.Windows.Forms.ToolStripMenuItem deleteMenuItem;
     private System.Windows.Forms.ToolStripMenuItem publishMenuItem;
     private System.Windows.Forms.ToolStripMenuItem installPluginFromFileToolStripMenuItem;
Index: trunk/sources/HeuristicLab.PluginInfrastructure.GUI/ManagerForm.resx
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure.GUI/ManagerForm.resx	(revision 17)
+++ trunk/sources/HeuristicLab.PluginInfrastructure.GUI/ManagerForm.resx	(revision 18)
@@ -257,5 +257,5 @@
 </value>
   </data>
-  <data name="removeButton.Image" type="System.Drawing.Bitmap, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
+  <data name="deleteButton.Image" type="System.Drawing.Bitmap, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
     <value>
         iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8