Index: /trunk/sources/HeuristicLab/CopyAssemblies.cmd
===================================================================
--- /trunk/sources/HeuristicLab/CopyAssemblies.cmd	(revision 39)
+++ /trunk/sources/HeuristicLab/CopyAssemblies.cmd	(revision 39)
@@ -0,0 +1,37 @@
+copy "..\..\..\HeuristicLab.PluginInfrastructure.GUI\ICSharpCode.SharpZipLib License.txt" .\
+
+rmdir plugins /s /q 
+mkdir plugins
+mkdir plugins\cache
+mkdir plugins\temp
+mkdir plugins\backup
+copy "..\..\..\HeuristicLab.AdvancedOptimizationFrontend\bin\%1\HeuristicLab.AdvancedOptimizationFrontend.dll" .\plugins
+copy "..\..\..\HeuristicLab.AdvancedOptimizationFrontend\WeifenLuo.WinFormsUI.Docking.dll" .\plugins
+copy "..\..\..\HeuristicLab.AdvancedOptimizationFrontend\WeifenLuo.WinFormsUI.Docking License.txt" .\plugins
+copy "..\..\..\HeuristicLab.BitVector\bin\%1\HeuristicLab.BitVector.dll" .\plugins
+copy "..\..\..\HeuristicLab.Charting\bin\%1\HeuristicLab.Charting.dll" .\plugins
+copy "..\..\..\HeuristicLab.Charting.Data\bin\%1\HeuristicLab.Charting.Data.dll" .\plugins
+copy "..\..\..\HeuristicLab.Core\bin\%1\HeuristicLab.Core.dll" .\plugins
+copy "..\..\..\HeuristicLab.Constraints\bin\%1\HeuristicLab.Constraints.dll" .\plugins
+copy "..\..\..\HeuristicLab.Data\bin\%1\HeuristicLab.Data.dll" .\plugins
+copy "..\..\..\HeuristicLab.DataAnalysis\bin\%1\HeuristicLab.DataAnalysis.dll" .\plugins
+copy "..\..\..\HeuristicLab.DistributedEngine\bin\%1\HeuristicLab.DistributedEngine.dll" .\plugins
+copy "..\..\..\HeuristicLab.Evolutionary\bin\%1\HeuristicLab.Evolutionary.dll" .\plugins
+copy "..\..\..\HeuristicLab.Functions\bin\%1\HeuristicLab.Functions.dll" .\plugins
+copy "..\..\..\HeuristicLab.Grid\bin\%1\HeuristicLab.Grid.dll" .\plugins
+copy "..\..\..\HeuristicLab.Logging\bin\%1\HeuristicLab.Logging.dll" .\plugins
+copy "..\..\..\HeuristicLab.Operators\bin\%1\HeuristicLab.Operators.dll" .\plugins
+copy "..\..\..\HeuristicLab.Operators.Programmable\bin\%1\HeuristicLab.Operators.Programmable.dll" .\plugins
+copy "..\..\..\HeuristicLab.OptimizationFrontend\bin\%1\HeuristicLab.OptimizationFrontend.dll" .\plugins
+copy "..\..\..\HeuristicLab.Permutation\bin\%1\HeuristicLab.Permutation.dll" .\plugins
+copy "..\..\..\HeuristicLab.Random\bin\%1\HeuristicLab.Random.dll" .\plugins
+copy "..\..\..\HeuristicLab.RealVector\bin\%1\HeuristicLab.RealVector.dll" .\plugins
+copy "..\..\..\HeuristicLab.Routing.TSP\bin\%1\HeuristicLab.Routing.TSP.dll" .\plugins
+copy "..\..\..\HeuristicLab.Scheduling.JSSP\bin\%1\HeuristicLab.Scheduling.JSSP.dll" .\plugins
+copy "..\..\..\HeuristicLab.Selection\bin\%1\HeuristicLab.Selection.dll" .\plugins
+copy "..\..\..\HeuristicLab.Selection.OffspringSelection\bin\%1\HeuristicLab.Selection.OffspringSelection.dll" .\plugins
+copy "..\..\..\HeuristicLab.SequentialEngine\bin\%1\HeuristicLab.SequentialEngine.dll" .\plugins
+copy "..\..\..\HeuristicLab.SGA\bin\%1\HeuristicLab.SGA.dll" .\plugins
+copy "..\..\..\HeuristicLab.StructureIdentification\bin\%1\HeuristicLab.StructureIdentification.dll" .\plugins
+copy "..\..\..\HeuristicLab.TestFunctions\bin\%1\HeuristicLab.TestFunctions.dll" .\plugins
+copy "..\..\..\HeuristicLab.ThreadParallelEngine\bin\%1\HeuristicLab.ThreadParallelEngine.dll" .\plugins
Index: /trunk/sources/HeuristicLab/HeuristicLab.csproj
===================================================================
--- /trunk/sources/HeuristicLab/HeuristicLab.csproj	(revision 38)
+++ /trunk/sources/HeuristicLab/HeuristicLab.csproj	(revision 39)
@@ -77,5 +77,4 @@
       <LastGenOutput>Settings.Designer.cs</LastGenOutput>
     </None>
-    <None Include="UpdateAssemblies.cmd" />
     <Compile Include="Properties\Settings.Designer.cs">
       <AutoGen>True</AutoGen>
@@ -104,4 +103,5 @@
     <Content Include="Resources\HeuristicLab.ico" />
     <None Include="app.config" />
+    <None Include="CopyAssemblies.cmd" />
     <None Include="Properties\AssemblyInfo.frame" />
     <None Include="Resources\LargeIcons.gif" />
@@ -109,4 +109,5 @@
     <None Include="Resources\List.gif" />
     <None Include="Resources\Logo_white.gif" />
+    <None Include="UpdateLocalInstallation.cmd" />
   </ItemGroup>
   <Import Project="$(MSBuildBinPath)\Microsoft.CSharp.targets" />
@@ -119,5 +120,6 @@
   -->
   <PropertyGroup>
-    <PostBuildEvent>cmd /c ..\..\UpdateAssemblies.cmd $(ConfigurationName)</PostBuildEvent>
+    <PostBuildEvent>cmd /c ..\..\CopyAssemblies.cmd $(ConfigurationName)
+cmd /c ..\..\UpdateLocalInstallation.cmd $(ConfigurationName)</PostBuildEvent>
     <PreBuildEvent>cmd /c ..\..\..\PreBuildEvent.cmd</PreBuildEvent>
   </PropertyGroup>
Index: unk/sources/HeuristicLab/UpdateAssemblies.cmd
===================================================================
--- /trunk/sources/HeuristicLab/UpdateAssemblies.cmd	(revision 38)
+++ 	(revision )
@@ -1,37 +1,0 @@
-copy "..\..\..\HeuristicLab.PluginInfrastructure.GUI\ICSharpCode.SharpZipLib License.txt" .\
-
-rmdir plugins /s /q 
-mkdir plugins
-mkdir plugins\cache
-mkdir plugins\temp
-mkdir plugins\backup
-copy "..\..\..\HeuristicLab.AdvancedOptimizationFrontend\bin\%1\HeuristicLab.AdvancedOptimizationFrontend.dll" .\plugins
-copy "..\..\..\HeuristicLab.AdvancedOptimizationFrontend\WeifenLuo.WinFormsUI.Docking.dll" .\plugins
-copy "..\..\..\HeuristicLab.AdvancedOptimizationFrontend\WeifenLuo.WinFormsUI.Docking License.txt" .\plugins
-copy "..\..\..\HeuristicLab.BitVector\bin\%1\HeuristicLab.BitVector.dll" .\plugins
-copy "..\..\..\HeuristicLab.Charting\bin\%1\HeuristicLab.Charting.dll" .\plugins
-copy "..\..\..\HeuristicLab.Charting.Data\bin\%1\HeuristicLab.Charting.Data.dll" .\plugins
-copy "..\..\..\HeuristicLab.Core\bin\%1\HeuristicLab.Core.dll" .\plugins
-copy "..\..\..\HeuristicLab.Constraints\bin\%1\HeuristicLab.Constraints.dll" .\plugins
-copy "..\..\..\HeuristicLab.Data\bin\%1\HeuristicLab.Data.dll" .\plugins
-copy "..\..\..\HeuristicLab.DataAnalysis\bin\%1\HeuristicLab.DataAnalysis.dll" .\plugins
-copy "..\..\..\HeuristicLab.DistributedEngine\bin\%1\HeuristicLab.DistributedEngine.dll" .\plugins
-copy "..\..\..\HeuristicLab.Evolutionary\bin\%1\HeuristicLab.Evolutionary.dll" .\plugins
-copy "..\..\..\HeuristicLab.Functions\bin\%1\HeuristicLab.Functions.dll" .\plugins
-copy "..\..\..\HeuristicLab.Grid\bin\%1\HeuristicLab.Grid.dll" .\plugins
-copy "..\..\..\HeuristicLab.Logging\bin\%1\HeuristicLab.Logging.dll" .\plugins
-copy "..\..\..\HeuristicLab.Operators\bin\%1\HeuristicLab.Operators.dll" .\plugins
-copy "..\..\..\HeuristicLab.Operators.Programmable\bin\%1\HeuristicLab.Operators.Programmable.dll" .\plugins
-copy "..\..\..\HeuristicLab.OptimizationFrontend\bin\%1\HeuristicLab.OptimizationFrontend.dll" .\plugins
-copy "..\..\..\HeuristicLab.Permutation\bin\%1\HeuristicLab.Permutation.dll" .\plugins
-copy "..\..\..\HeuristicLab.Random\bin\%1\HeuristicLab.Random.dll" .\plugins
-copy "..\..\..\HeuristicLab.RealVector\bin\%1\HeuristicLab.RealVector.dll" .\plugins
-copy "..\..\..\HeuristicLab.Routing.TSP\bin\%1\HeuristicLab.Routing.TSP.dll" .\plugins
-copy "..\..\..\HeuristicLab.Scheduling.JSSP\bin\%1\HeuristicLab.Scheduling.JSSP.dll" .\plugins
-copy "..\..\..\HeuristicLab.Selection\bin\%1\HeuristicLab.Selection.dll" .\plugins
-copy "..\..\..\HeuristicLab.Selection.OffspringSelection\bin\%1\HeuristicLab.Selection.OffspringSelection.dll" .\plugins
-copy "..\..\..\HeuristicLab.SequentialEngine\bin\%1\HeuristicLab.SequentialEngine.dll" .\plugins
-copy "..\..\..\HeuristicLab.SGA\bin\%1\HeuristicLab.SGA.dll" .\plugins
-copy "..\..\..\HeuristicLab.StructureIdentification\bin\%1\HeuristicLab.StructureIdentification.dll" .\plugins
-copy "..\..\..\HeuristicLab.TestFunctions\bin\%1\HeuristicLab.TestFunctions.dll" .\plugins
-copy "..\..\..\HeuristicLab.ThreadParallelEngine\bin\%1\HeuristicLab.ThreadParallelEngine.dll" .\plugins
Index: /trunk/sources/HeuristicLab/UpdateLocalInstallation.cmd
===================================================================
--- /trunk/sources/HeuristicLab/UpdateLocalInstallation.cmd	(revision 39)
+++ /trunk/sources/HeuristicLab/UpdateLocalInstallation.cmd	(revision 39)
@@ -0,0 +1,9 @@
+set target=C:\Program Files\HeuristicLab 3.0
+
+copy "HeuristicLab.exe" "%target%"
+copy "HeuristicLab.exe.config" "%target%"
+copy "HeuristicLab.PluginInfrastructure.dll" "%target%"
+copy "HeuristicLab.PluginInfrastructure.GUI.dll" "%target%"
+copy "ICSharpCode.SharpZipLib.dll" "%target%"
+copy "ICSharpCode.SharpZipLib License.txt" "%target%"
+copy "plugins\*.*" "%target%\plugins"